//
//  UIView+histTest.m
//  视图的响应链
//
//  Created by likaifeng on 2017/5/15.
//  Copyright © 2017年 lukai. All rights reserved.
//

#import "UIView+histTest.h"
#import <objc/runtime.h>

@implementation UIView (histTest)


+(void)load{
    
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
      
        Method methA = class_getInstanceMethod(self, @selector(hitTest:withEvent:));
        Method methB = class_getInstanceMethod(self, @selector(kk_hitTest:withEvent:));
        
        BOOL isAdd = class_addMethod(self, @selector(hitTest:withEvent:), method_getImplementation(methB), method_getTypeEncoding(methB));
        
        if (isAdd) {
            class_replaceMethod(self, @selector(kk_hitTest:withEvent:), method_getImplementation(methA), method_getTypeEncoding(methA));
        }else{
            method_exchangeImplementations(methA, methB);
        }
    });

}


-(UIView *)kk_hitTest:(CGPoint)point withEvent:(UIEvent *)event{
    
    if (!self.clipsToBounds && self.alpha>0 && self.hidden == NO) {
        
        for (UIView *subView in self.subviews) {
            
            CGPoint kk_point = [self convertPoint:point toView:subView];
            UIView *view = [subView hitTest:kk_point withEvent:event];
            if (view) {
                return view;
            }
        }
        
    }
    return [self kk_hitTest:point withEvent:event];
}

@end
